
// temporary global (per-browser) data structure that holds the note
function Note() {}  // constructor

Note.prototype = {
  url : null,
  summary : "",
  details : "",
  chop_query : true, home_page : false,
  width : 100, height : 90, top : 80, left : 70,
  clear : function () {
    this.url = null;
  },
  resolve : function (url) {
    this.url = url;
  },
}

var note = new Note();

// all actions for the toolbar window
function action(task)
{
  if ( task == "notetaker-open-dialog" )
  {
    window.openDialog("editDialog.xul","_blank","modal=yes");
    refresh_toolbar();
  }

  if ( task == "notetaker-display" )
  {
    display_note();
  }

  if ( task == "notetaker-save" )
  {
    refresh_toolbar();
  }
  if ( task == "notetaker-delete" )
  {
    refresh_toolbar();
  }
}

// draw a note on an existing HTML page
function display_note()
{
  var style = generate_style();
  var html = generate_html();
  var doc = window.content.document;

  var stree = doc.getElementById("notetaker-styles");
  if ( !stree )		// add the topmost <style>
  {
     stree = doc.createElement("style");
     stree.setAttribute("id","notetaker-styles");
     var head = doc.getElementsByTagName('head').item(0);
     head.appendChild(stree);
  }
  stree.innerHTML = style;

  var htree = doc.getElementById("notetaker-note");
  if ( !htree )		// add the topmost <span>
  {
    htree = doc.createElement("span");
    htree.setAttribute("id","notetaker-note");
    var body = doc.getElementsByTagName('body').item(0);
    body.appendChild(htree);
  }
  htree.innerHTML = html;
}

// populate the HTML content of the note with data and return it
function generate_html()
{
  var source = '<span id="notetaker-note-summary">{summary}</span>' +
               '<span id="notetaker-note-details">{details}</span>';

  source = source.replace(/\{summary\}/, note.summary);
  source = source.replace(/\{details\}/, note.details);

  return source;
}

// populate the HTML content of the note with data and return it
function generate_style()
{
  var source = "#notetaker-note {" + 
    "display:block; position:absolute; z-index:2147483646; overflow:auto;" + 
    "background-color:lightyellow; border:solid; border-color:yellow;"  + 
    "width:{width}px; height:{height}px; top:{top}px; left:{left}px; }\n" + 

    "#notetaker-note-summary { display:block; font-weight:bold; }\n" + 

    "#notetaker-note-details { display:block; margin-top:5px; }\n";

  source = source.replace(/\{width\}/, note.width);
  source = source.replace(/\{height\}/, note.height);
  source = source.replace(/\{top\}/, note.top);
  source = source.replace(/\{left\}/, note.left);

  return source;
}

// display the note as soon as there's content

function content_poll()
{
  var doc;
  try {
    if ( !window.content ) throw('fail');
    doc = window.content.document;
    if ( !doc ) throw('fail');
    if ( doc.getElementsByTagName("body").length == 0 ) throw('fail');
    if ( doc.location.href == "about:blank" ) throw('fail');
  }
  catch (e) {
    note.clear();
    refresh_toolbar();
    return;
  }
  
  if ( doc.visited ) return;

  note.resolve(doc.location.href);
  display_note();
  refresh_toolbar();
  doc.visited = true;
}

setInterval("content_poll()", 5000);

function refresh_toolbar()
{
  var box = window.document.getElementById('notetaker-toolbar.summary');
  box.parentNode.setAttribute('ref', note.url);
  box.parentNode.builder.rebuild();

  var menu = window.document.getElementById('notetaker-toolbar.keywords');
  menu.firstChild.builder.rebuild();
}

